#!/bin/bash
#
# ----------------------------------------------------------------------------
# For details on this code see the books "z/VM and Linux on IBM System z:
# The Virtualization Cookbook for <x>" on the Web at: http://linuxvm.org/present
# where <x> is "SLES 10" or "RHEL 5"
#
# This code is shipped under the Common Public License. See the file
# Common-Public-License.txt or http://www.opensource.org/licenses/cpl1.0.txt
# ----------------------------------------------------------------------------
#
BACKUP="/backup/linux"
cd $BACKUP
for i in *-on-*            # iterate through dirs with "-on-" in their names 
do
  IP_addr=${i#*-on-}  # this chops the head off and grabs the IP address
  cd $BACKUP/$i            # change directory to next virtual server
  rsync -r --timeout=3 $IP_addr:/etc . > /dev/null 2>&1 # use rsync to backup
  rc=$?
  if [ $rc != 0 ]; then    # error
    echo "Error: rsync returned $rc while backing up $i"
  else  
    echo "Backing up $i seems to have succeeded"
  fi
done
