#!/bin/bash
# This script is part of the DAZL Web application
#
# ----------------------------------------------------------------------------
# For details on this code see the books "z/VM and Linux on IBM System z:
# The Virtualization Cookbook for <x>" on the Web at: http://linuxvm.org/present
# where <x> is "SLES 10" or "RHEL 5"
#
# This code is shipped under the Common Public License. See the file
# Common-Public-License.txt or http://www.opensource.org/licenses/cpl1.0.txt
# ----------------------------------------------------------------------------
#
#+--------------------------------------------------------------------------+
function createHeader ()
# create the HTML header
#+--------------------------------------------------------------------------+
 {
  echo "Content-type: text/html"
  echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'
  echo '<html xmlns="http://www.w3.org/1999/xhtml">'
  echo ""
  echo "<head>"
  echo '<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />'
  echo "<title>DAZL z/VM status</title>"
  echo "</head>"
 } # createHeader()

#---------------------------------------------------------------------------
function endPage()
#---------------------------------------------------------------------------
 {
  echo "</body>"
 }

#---------------------------------------------------------------------------
function startTable()
#---------------------------------------------------------------------------
 {
  echo "<table border=2>"
 }

#---------------------------------------------------------------------------
function endTable()
#---------------------------------------------------------------------------
 {
  echo "</table>"
 }

#---------------------------------------------------------------------------
function startRow()
#---------------------------------------------------------------------------
 {
  echo "<tr>"
 }

#---------------------------------------------------------------------------
function endRow()
#---------------------------------------------------------------------------
 {
  echo "</tr>"
 }

#---------------------------------------------------------------------------
function indCell()
# put output of "ind" in a table cell
#---------------------------------------------------------------------------
 {
  echo "<td>"
  echo "<h4>Indicate Load: <tt>IND</tt></h4>"
  echo "<pre>"
  sudo vmcp IND 
  echo ""
  echo "<a href=/cgi-bin/indQ.sh>IND QUEUES EXP</a>"
  echo "</pre>"
  echo "</td>"
 }

#---------------------------------------------------------------------------
function allocMapCell()
# put output of "ind" in a table cell
#---------------------------------------------------------------------------
 {
  echo "<td>"
  echo "<h4>Display system allocation: <tt>QUERY ALLOC MAP</tt></h4>"
  echo "<pre>"
  sudo vmcp QUERY ALLOC MAP 
  echo "</pre>"
  echo "</td>"
 }

#---------------------------------------------------------------------------
function qNamesCell()
# put output of "ind" in a table cell
#---------------------------------------------------------------------------
 {
  echo "<td>"
  echo "<h4>Display who is logged on/disconnected: <tt>QUERY NAMES</tt></h4>"
  echo "<pre>"
  sudo vmcp QUERY NAMES 
  echo "</pre>"
  echo "</td>"
 }

#---------------------------------------------------------------------------
function storageCell()
# put output of storage sizes in a table cell
#---------------------------------------------------------------------------
 {
  echo "<td>"
  echo "<h4>Display central/expanded storage: <tt>Q STOR/XSTOR</tt></h4>"
  echo "<pre>"
  sudo vmcp QUERY STOR 
  sudo vmcp QUERY XSTOR 
  echo "</pre>"
  echo "</td>"
 }

#---------------------------------------------------------------------------
function qCPlevelCell()
# put output of "q cplevel" in a table cell
#---------------------------------------------------------------------------
 {
  echo "<td>"
  echo "<h4>Display system service level: <tt>QUERY CPLEVEL</tt></h4>"
  echo "<pre>"
  sudo vmcp QUERY CPLEVEL 
  echo "</pre>"
  echo "</td>"
 }

#---------------------------------------------------------------------------
function qVswitchCell()
# put output of "Q VSWITCH"  in a table cell
#---------------------------------------------------------------------------
 {
  echo "<td>"
  echo "<h4>Display virtual switch info: <tt>QUERY VSWITCH</tt></h4>"
  echo "<pre>"
  sudo vmcp QUERY VSWITCH 
  echo ""
  echo "<a href=/cgi-bin/qVswitch.sh?DETAILS>Q VSWITCH DETAILS</a>"
  echo "<a href=/cgi-bin/qVswitch.sh?ACCESS>Q VSWITCH ACCESS</a>"
  echo "</pre>"
  echo "</td>"
 }

# main()
createHeader
startTable

startRow
indCell
allocMapCell
endRow

startRow
qNamesCell
storageCell
endRow

startRow
qCPlevelCell
qVswitchCell
endRow

endTable
endPage
