#!/bin/sh
# This script is part of the DAZL Web application
#
# ----------------------------------------------------------------------------
# For details on this code see the books "z/VM and Linux on IBM System z:
# The Virtualization Cookbook for <x>" on the Web at: http://linuxvm.org/present
# where <x> is "SLES 10" or "RHEL 5"
#
# This code is shipped under the Common Public License. See the file
# Common-Public-License.txt or http://www.opensource.org/licenses/cpl1.0.txt
# ----------------------------------------------------------------------------
#
DISKMAP="/backup/vm/USER.DISKMAP"
title="$QUERY_STRING volume in USER DISKMAP"
if [ ! $QUERY_STRING ]; then # this is not supposed to be
  error="yes"
  output="QUERY_STRING not set"
elif [ ! -f $DISKMAP ]; then
  error="yes"
  output="$DISKMAP not found"
else # there is a volume name and a USER DISKMAP file
  error="no"
  volSer=$QUERY_STRING
  startLine=`grep -n "^$volSer" $DISKMAP | awk -F: '{ print $1 }'`
  if [ ! $startLine ]; then # volume not found 
    error="yes"
    output="Volume $volSer not found in $DISKMAP"
  else # the volume was found - extract the appropriate lines
    numLines=`wc -l $DISKMAP | awk '{ print $1 }'`
    let tailLines=$numLines-$startLine
    linesInEntry=`tail -$tailLines $DISKMAP | grep -n "^-" | head -1 | awk -F: '{ print $1 }'`
    if [ ! $linesInEntry ]; then # reached end of file
      let linesToDisplay=$numLines-$startLine+4
    else
      let linesToDisplay=$linesInEntry+2
    fi
    let tailLines=$tailLines+4 
  fi
fi 

# create the page
echo "Content-type: text/html"
echo ""
echo "<head>"
echo "<title>$title</title>"
echo "</head>"
echo "<body>"
echo "<h2>$title</h2>"
echo "<pre>"
if [ "$error" = "yes" ]; then # there was an error
  echo "$output"
else
  tail -$tailLines $DISKMAP | head -$linesToDisplay
fi
echo "</pre>"
echo "</body>"
